#!/bin/sh

# Copyright  2014, Trond Endrestl <Trond.Endrestol@ximalas.info>
# All rights reserved.

# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:

# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#set -x

PATH=/usr/local/bin:/usr/local/sbin:/usr/bin:/usr/sbin:/bin:/sbin

# Old tool.
#PKG_INFO="pkg_info"

# New tool.
PKG_INFO="pkg info"

cd /usr/ports || exit 69

INSTALLED_PORTS="`${PKG_INFO} -aoq`"

NEW_DEPENDENCIES="";
for p in ${INSTALLED_PORTS}; do
  cd /usr/ports/${p};
  NEW_DEPENDENCIES="${NEW_DEPENDENCIES} `make missing`";
done
cd /tmp
SORTED_DEPENDENCIES="`for d in ${NEW_DEPENDENCIES}; do echo ${d}; done | sort | uniq`"
NEW_DEPENDENCIES="${SORTED_DEPENDENCIES}"

if [ -n "${NEW_DEPENDENCIES}" ]; then
  portupgrade -ncNfprv ${NEW_DEPENDENCIES} || exit;
  portupgrade -Nfprv ${NEW_DEPENDENCIES} || exit;
else
  echo "${0}: found no missing ports";
fi

# EOF
